var _excluded = ["portal", "type", "maskAttribute", "iconAttribute", "captionAttribute", "children", "caption"];

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { forwardRef, useContext } from 'react';
import { createPortal } from 'react-dom';
import locale from './../locale'; // 国际化数据

var Loading = forwardRef(function (_ref, ref) {
  var portal = _ref.portal,
      _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'floating' : _ref$type,
      _ref$maskAttribute = _ref.maskAttribute,
      maskAttribute = _ref$maskAttribute === void 0 ? {} : _ref$maskAttribute,
      iconAttribute = _ref.iconAttribute,
      _ref$captionAttribute = _ref.captionAttribute,
      captionAttribute = _ref$captionAttribute === void 0 ? {} : _ref$captionAttribute,
      children = _ref.children,
      _ref$caption = _ref.caption,
      caption = _ref$caption === void 0 ? locale('加载中...', 'loading') : _ref$caption,
      others = _objectWithoutPropertiesLoose(_ref, _excluded);

  var content = null;

  if (type === 'custom') {
    // 自定义样式
    content = /*#__PURE__*/React.createElement("div", _extends({}, others, {
      className: "loading-custom" + (others.className ? ' ' + others.className : '')
    }), iconAttribute && /*#__PURE__*/React.createElement("span", _extends({}, iconAttribute, {
      className: "loading-custom-icon" + (iconAttribute.className ? ' ' + iconAttribute.className : '')
    })), caption && /*#__PURE__*/React.createElement("p", _extends({}, captionAttribute, {
      className: "loading-custom-caption" + (captionAttribute.className ? ' ' + captionAttribute.className : '')
    }), caption));
  } else if (type === 'filling') {
    // 填料环
    content = /*#__PURE__*/React.createElement("div", _extends({}, others, {
      className: "loading-filling active" + (others.className ? ' ' + others.className : '')
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-filling-icon"
    }));
  } else if (type === 'floating') {
    // 流光
    content = /*#__PURE__*/React.createElement("div", _extends({}, others, {
      className: "loading-floating animated" + (others.className ? ' ' + others.className : '')
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-icon"
    }, /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    }), /*#__PURE__*/React.createElement("div", {
      className: "loading-floating-blade"
    })), caption && /*#__PURE__*/React.createElement("div", _extends({}, captionAttribute, {
      className: "loading-floating-caption" + (captionAttribute.className ? ' ' + captionAttribute.className : '')
    }), caption));
  }

  if (portal) {
    return createPortal( /*#__PURE__*/React.createElement("div", _extends({
      ref: ref
    }, maskAttribute, {
      className: 'loading-mask mask active' + (maskAttribute.className ? ' ' + maskAttribute.className : '')
    }), content, children), portal);
  }

  return /*#__PURE__*/React.createElement("div", _extends({
    ref: ref
  }, maskAttribute, {
    className: 'loading-mask mask active' + (maskAttribute.className ? ' ' + maskAttribute.className : '')
  }), content, children);
});
export default Loading;